#ifndef BFW_MOTOKO_DRAW_H
#define BFW_MOTOKO_DRAW_H

typedef struct
{
	unsigned short Width;
	unsigned short Height;
	unsigned short Depth;
	unsigned short __unused;
} M3tDisplayMode;

typedef struct
{
	int Type;
	char Name[64];
	char a[64];
	int b, c, d;
	short DisplayModeCount;
	M3tDisplayMode DisplayModes[12];
	char e[990];
} M3tDrawEngineCaps;

typedef struct
{
	int Context_New;
	int Context_Delete;
	int Texture_ResetAll;
	int PrivateState_Size;
	int PrivateState_New;
	int PrivateState_Delete;
	int State_Update;
} M3tDrawEngine;

typedef struct
{
	int FrameStart;
	int FrameEnd;
	int FrameSync;
	int Triangle;
	int Quad;
	int Pent;
	int Line;
	int Point;
	int TriSprite;
	int Sprite;
	int SpriteArray;
	int ScreenCapture;
	int PointVisible;
	int SupportsPointVisible;
	int TextureFormatAvailable;
	int SetResolution;
	int ResetFog;
	int TextureLoad;
	int TextureUnload;
	int SinglePassMultitextureCapable;
} M3tDrawContext;

typedef struct
{
	float *Position;
	int *Color;
	float *TexCoord0;
	float *TexCoord1;
	void *Texture0;
	void *Texture1;
	void *State6;
	void *State7;
	void *State8;
} M3tDrawPtrState;

extern char M3gResolutionSwitch;

#endif
